{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 
  Versión actual: 1.0.0
  Fecha versión actual: 
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uBizTiposIVA;

interface

uses
  uDAInterfaces, uDADataTable, uDBSelectionListUtils, schTiposIVAClient_Intf;

const
  BIZ_CLIENT_TIPOIVA = 'Client.TipoIVA';

type
  IBizTipoIVA = interface(ITiposIVA)
  	['{72B85541-E871-4804-8DB9-ED76278307D5}']    
    function EsNuevo : Boolean;
    
  	// Descomentar esto si hay clases detalles
    // procedure SetDetalles(AValue : IBizDetalles);
    // function GetDetalles : IBizDetalles;
    // property Detalles : IBizDetalles read GetDetalles write SetDetalles;  
  end;

  TBizTipoIVA = class(TTiposIVADataTableRules, IBizTipoIVA, ISeleccionable)
  protected
  	FSeleccionableInterface : ISeleccionable;
  	
  	// Descomentar esto si hay clases detalles
    // FDetalles : IBizDetalles;
    // FDetallesLink : TDADataSource;
    // procedure SetDetalles(AValue : IBizDetalles);
    // function GetDetalles : IBizDetalles;

    procedure OnNewRecord(Sender: TDADataTable); override;
  public
    procedure IniciarValoresTipoIVANuevo;
    function EsNuevo : Boolean;
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

    property SeleccionableInterface : ISeleccionable 
    					read FSeleccionableInterface
    					write FSeleccionableInterface 
    					implements ISeleccionable;
    
  	// Descomentar esto si hay clases detalles
    // property Detalles : IBizDetalles read GetDetalles write SetDetalles;    
  end;

implementation

{ TBizTipoIVA }

uses
  SysUtils, uDataTableUtils;

// Descomentar esto si hay clases detalles
// function TBizTipoIVA.GetDetalles: IBizDetalles;
// begin
//   Result := FDetalles;
// end;

// Descomentar esto si hay clases detalles
// procedure TBizTipoIVA.SetDetalles(AValue: IBizDetalles);
// begin
//   FDetalles := AValue;
//   EnlazarMaestroDetalle(FDetallesLink, FDetalles);
// end;

constructor TBizTipoIVA.Create(aDataTable: TDADataTable);
begin
  inherited;
  // Descomentar esto si hay clases detalles
  // FDetallesLink := TDADataSource.Create(NIL);
  // FDetallesLink.DataTable := aDataTable;  
  
	FSeleccionableInterface := TSeleccionable.Create(aDataTable);  
end;

destructor TBizTipoIVA.Destroy;
begin
	// Descomentar esto si hay clases detalles
  // FDetalles := NIL;
  // FreeAndNIL(FDetallesLink);	
  
  FSeleccionableInterface := NIL;
  inherited;
end;

function TBizTipoIVA.EsNuevo: Boolean;
begin
  Result := (ID < 0);
end;

procedure TBizTipoIVA.IniciarValoresTipoIVANuevo;
begin
  //
end;

procedure TBizTipoIVA.OnNewRecord(Sender: TDADataTable);
begin
  inherited;
  ID := GetRecNo; // -1, -2, -3...
  IniciarValoresTipoIVANuevo;
end;

initialization
  RegisterDataTableRules(BIZ_CLIENT_TIPOIVA, TBizTipoIVA);

finalization

end.

